# -*- coding: utf-8 -*-

# Script Mapping for Devanagari
# Transliterating other arabic sounds from Thaana to others

VowelMap =  [
            '\u0787\u07A6',
            '\u0787\u07A7',
            '\u0787\u07A8',
            '\u0787\u07A9',
            '\u0787\u07AA',
            '\u0787\u07AB',
            '\u0783\u07AA',
            '\u0783\u07AB',
            '\u078D\u07AA',
            '\u078D\u07AB',
            '\u0787\u07AD',
            '\u0787\u07A6\u0787\u07A8\u02BD',
            '\u0787\u07AF',
            '\u0787\u07A6\u0787\u07AA\u02BD',
            ]

SouthVowelMap = [
                '\u0787\u07AC',
                '\u0787\u07AE',
                ]

ModernVowelMap = [
                 '\u0787\u07AC\u02BD',
                 '\u0787\u07A7\u02BD',
                 ]

SinhalaVowelMap = [
                  '\u0787\u07AD\u02BD'
                  ]

VowelSignMap =  [
                '\u07A7',
                '\u07A8',
                '\u07A9',
                '\u07AA',
                '\u07AB',
                '\u07B0\u0783\u07AA',
                '\u07B0\u0783\u07AB',
                '\u07B0\u078D\u07AA',
                '\u07B0\u078D\u07AB',
                '\u07AD',
                '\u07A6\u0787\u07A8\u02BD',
                '\u07AF',
                '\u07A6\u0787\u07AA\u02BD',
                ]

SouthVowelSignMap = [
                    '\u07AC',
                    '\u07AE',
                    ]

ModernVowelSignMap =[
                    '\u07AC\u02BD',
                    '\u07A7\u02BD']

SinhalaVowelSignMap = [
                      '\u07AD\u02BD'
                      ]

AyogavahaMap = [
               '\u0789\u07B0\u02BD',
               '\u0789\u07B0\u02BD',
               '\u0780\u07A6\u07B0\u02BD'
               ]

ViramaMap =  [
             '\u07B0'
             ]

ConsonantMap =  [
                '\u0786\u07A6',
                '\u0786\u02BD\u07A6',
                '\u078E\u07A6',
                '\u078E\u02BD\u07A6',
                '\u0782\u02BD\u07A6',

                '\u0797\u07A6',
                '\u0797\u02BD\u07A6',
                '\u0796\u07A6',
                '\u0796\u02BD\u07A6',
                '\u078F\u07A6',

                '\u0793\u07A6',
                '\u0793\u02BD\u07A6',
                '\u0791\u07A6',
                '\u0791\u02BD\u07A6',
                '\u07B1\u07A6',

                '\u078C\u07A6',
                '\u078C\u02BD\u07A6',
                '\u078B\u07A6',
                '\u078B\u02BD\u07A6',
                '\u0782\u07A6',

                '\u0795\u07A6',
                '\u0795\u02BD\u07A6',
                '\u0784\u07A6',
                '\u0784\u02BD\u07A6',
                '\u0789\u07A6',

                '\u0794\u07A6',
                '\u0783\u07A6',
                '\u078D\u07A6',
                '\u0788\u07A6',

                '\u079D\u07A6',
                '\u0781\u07A6',
                '\u0790\u07A6',
                '\u0780\u07A6'
                ]

SouthConsonantMap = [
                    '\u0785\u07A6',
                    '\u0785\u02BD\u07A6',
                    '\u0783\u02BD\u07A6',
                    '\u0782\u02BD\u07A6'
                    ]

NuktaConsonantMap =  [
                     '\u07A4\u07A6',
                     '\u079A\u07A6',
                     '\u07A3\u07A6',
                     'ޒ\u07A6',
                     '\u0791\u02BD\u07A6',
                     '\u0791\u02BD\u07A6',
                     '\u078A\u07A6',
                     '\u0794\u02BD\u07A6'
                     ]

SinhalaConsonantMap =[
                     '\u0782\u078E\u07A6',
                     '\u0782\u0796\u07A6',
                     '\u0782\u0791\u07A6',
                     '\u0782\u078B\u07A6',
                     '\u0782\u0784\u07A6',
                      ]

NuktaMap = [
           '\u02BD\u02BD\u02BD'
           ]

OmMap = [
        '\u0787\u07AF\u0789\u07A6\u07B0'
        ]

SignMap =[
         '\u02BD\u02BD',
         '\u06D4',
         '\u06D4\u06D4'
         ]

Aytham =[AyogavahaMap[2]+'\u02BD']

NumeralMap = [
             '\u0030',
             '\u0031',
             '\u0032',
             '\u0033',
             '\u0034',
             '\u0035',
             '\u0036',
             '\u0037',
             '\u0038',
             '\u0039',
             ]